// script file used by cheap.html, csim-p.html

var
  endl  = ((navigator.userAgent.search('MSIE')  != -1) && 
           (navigator.userAgent.search('Opera') == -1)) ? '\n\r' : '\n',

  endlKon = navigator.userAgent.search('Konqueror') == -1 ? '' : endl,
  
  endl3 = (endl2 = endl + endl) + endl,

  enhData = { 
    chBspSrcTd:
                         endlKon
      + 'JMP  4'       + endl3
      + 'DW  10'       + endl2
      + 'DW  20'       + endl2
      + 'DW   0'       + endl3
      + 'SET r01, 1'   + endl2
      + 'LW  r02, r01' + endl2
      + 'ADD r01, 1'   + endl2
      + 'LW  r03, r01' + endl3
      + 'ADD r02, r03' + endl2
      + 'ADD r01, 1'   + endl2
      + 'SW  r02, r01' + endl3
      + 'JMP 4095',
    chBspSrcTh:
        'asm source',

    chBspDstTd:
                         endlKon
      + 'C0000004'     + endl3
      + '0000000A'     + endl2
      + '00000014'     + endl2
      + '00000000'     + endl3
      + '20400001'     + endl2
      + '00820030'     + endl2
      + '28400001'     + endl2
      + '00C20030'     + endl3
      + '00860005'     + endl2
      + '28400001'     + endl2
      + '00820031'     + endl3
      + 'C0000FFF',
    chBspDstTh:
        'final binary',

    csAddBspTd:
        'JMP  4                          ; jump beyond data                ' + endl2
      + 'DW  10                          ; some data here'                   + endl
      + 'DW  20'                                                             + endl
      + 'DW   0'                                                             + endl2
      + 'SET r01, 1                      ; point to first number'            + endl
      + 'LW  r02, r01                    ; load it'                          + endl
      + 'ADD r01, 1                      ; point to next number'             + endl
      + 'LW  r03, r01                    ; load it'                          + endl2
      + 'ADD r02, r03                    ; add numbers'                      + endl
      + 'ADD r01, 1                      ; point to next position'           + endl
      + 'SW  r02, r01                    ; safe result'                      + endl2
      + 'JMP 4095                        ; program end',
    csAddBspTh:
        'assembler source',

    csBstBspTd:
        'SET r01, (data)'                                                    + endl
      + 'LW  r04, r01                    ; load char from string'            + endl
      + 'BEZ r04, 4095                   ; check char for string terminator' + endl
      + 'SET r05, r04'                                                       + endl
      + 'CST r05, 96                     ; check char for small letter'      + endl
      + 'BEZ r05, (isCap)'                                                   + endl
      + 'SET r05, r04'                                                       + endl
      + 'CGT r05, 124'                                                       + endl
      + 'BEZ r05, (isCap)'                                                   + endl
      + 'SUB r04, 32                     ; change to capital letter'         + endl2
      + '(isCap)'                                                            + endl
      + 'SW  r04, r01                    ; write capital letter to memory'   + endl
      + 'ADD r01, 1                      ; new loop for next char'           + endl
      + 'JMP 1'                                                              + endl2
      + '(data)'                                                             + endl
      + 'DW  \'> cheapAsm <\''                                               + endl
      + 'DW  0',
    csBstBspTh:
        'assembler source'
  };

function enhance(enhId) {
  var baseNode = document.getElementById(enhId + 'Td');

  if ( baseNode.firstChild.firstChild.nodeValue == ' ') {
    baseNode.firstChild.firstChild.nodeValue = enhData[enhId + 'Td'];
    baseNode.style.backgroundColor = 'lightsteelblue';
    
    baseNode = document.getElementById(enhId + 'Th')
    baseNode.firstChild.firstChild.nodeValue = enhData[enhId + 'Th'];
    baseNode.firstChild.setAttribute('title', 'hide ' + enhData[enhId + 'Th'])
    baseNode.style.backgroundColor = 'steelblue';
  }
  else {
    baseNode.firstChild.firstChild.nodeValue = ' ';
    baseNode.style.backgroundColor = 'white';
    
    baseNode = document.getElementById(enhId + 'Th')
    baseNode.firstChild.firstChild.nodeValue = '++';
    baseNode.firstChild.setAttribute('title', 'show ' + enhData[enhId + 'Th'])
    baseNode.style.backgroundColor = 'white';
  }
}
